SystemOrganization addCategory: #AMP!

WebWidget subclass: #AMPFileElement
	instanceVariableNames: 'file observee player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMP'!

!AMPFileElement class methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 11:24'!
new
	^ super new method: #ajaxStarter:.
! !

!AMPFileElement methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 13:17'!
ajaxStarter: aString
	Transcript show: self file name; cr.
	self elements first class:'playing'.
	self player playSong: self file.! !

!AMPFileElement methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 11:43'!
file
	^file! !

!AMPFileElement methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 11:27'!
file:aFile
	file:= aFile! !

!AMPFileElement methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 13:16'!
player
	^player! !

!AMPFileElement methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 13:16'!
player: anAMPMusicPlayer
	player:=anAMPMusicPlayer! !

WebWidget subclass: #AMPFolderElement
	instanceVariableNames: 'folder player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMP'!

!AMPFolderElement class methodsFor: 'instance creation' stamp: 'lw 11/3/2010 13:13'!
for: aFolder playingOn: anAMPMusicPlayer
	
	| new |
	new := self new folder: aFolder.
	new player: anAMPMusicPlayer.
	^new! !

!AMPFolderElement class methodsFor: 'instance creation' stamp: 'SW 11/3/2010 10:36'!
new
	^ super new method: #ajaxStarter:.
! !

!AMPFolderElement methodsFor: 'events-ajax' stamp: 'lw 11/3/2010 13:24'!
ajaxStarter: aString
	
	self elements size < 3 
		ifTrue: [.
			(self folder entries select: [:entry | entry isDirectory ]) 
				do: [:entry | | div label |	
					self add: (AMPFolderElement for: entry asFileDirectory playingOn: self player)].
			(self folder entries select: [:entry | entry isDirectory not ]) 
				do: [:entry | | div label|	
					div := AMPFileElement new class: #ampfile; div:true.
					div file:entry.
					div player: self player.
					label := WebElement new div:true..
					label addText: entry name.
					div add:label.			
					label onClickUpdate: div.
					self add: div]] 
		ifFalse: [
			self explore]! !

!AMPFolderElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 12:59'!
folder
	^folder! !

!AMPFolderElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 13:12'!
folder: aFolder
	folder:= aFolder.
	self addText: aFolder name.! !

!AMPFolderElement methodsFor: 'initialization' stamp: 'lw 11/3/2010 13:14'!
initialize

	(self addNilLinkText: '+ ')
		onClickUpdate: self.! !

!AMPFolderElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 12:59'!
player
	^player! !

!AMPFolderElement methodsFor: 'accessing' stamp: 'lw 11/3/2010 12:57'!
player: aMusicPlayer
	player:=aMusicPlayer! !

WebWidget subclass: #AMPStopButton
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMP'!

!AMPStopButton class methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:32'!
for: aPlayer

	^self new player: aPlayer! !

!AMPStopButton class methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:40'!
new

	^super new method: #ajaxStopPlayback! !

!AMPStopButton methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:44'!
ajaxStopPlayback

	self player stopSong! !

!AMPStopButton methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:44'!
initialize
	
	self method: #ajaxStopPlayback.
	(self addNilLinkText: 'stop')
		onClickUpdate: self! !

!AMPStopButton methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:25'!
player

	^player! !

!AMPStopButton methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:24'!
player: aPlayer

	player := aPlayer! !

WebApplication subclass: #AMPMusicPlayerApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMP'!

!AMPMusicPlayerApp class methodsFor: 'as yet unclassified' stamp: 'SW 11/3/2010 10:26'!
register
	| x amp hostname ip siteName styleClass |

	amp _ AMPMusicPlayer new.
	
	hostname:= '*'. 
	ip := '*'.
	styleClass := 'WebStyle'. 
	siteName := 'mysite'.
	(AIDASite named: siteName) isNil ifTrue: [
		x _ AIDASite new name: siteName.
		x  host: hostname ip: ip port: 8000.
		x styleClass: styleClass.	
		SwazooServer singleton addSite: x.
		SwazooServer startSite: siteName.	].		
	(AIDASite named: siteName) urlResolver defaultURL: '/' forObject: amp.
	AIDASite default: siteName.! !

!AMPMusicPlayerApp methodsFor: 'as yet unclassified' stamp: 'SW 11/2/2010 09:51'!
clear! !

!AMPMusicPlayerApp methodsFor: 'as yet unclassified' stamp: 'SW 11/2/2010 12:31'!
clickEventFor:aEntry
|e|
e := WebElement new.
e style: ''.
e addTextBold: 'play'.
Transcript show: 'clickEventFor', aEntry.
^e
! !

!AMPMusicPlayerApp methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 13:13'!
viewMain
	| e rootDir |
	e _ WebElement new.
	e addTextH1: 'Hello World'.
	rootDir := self observee rootDirectory.
	e add: (AMPFolderElement for: rootDir playingOn: self observee).
	e add: (AMPStopButton for: self observee).
	self style pageFrameWith: e title:'blub'.! !

Object subclass: #AMPMusicPlayer
	instanceVariableNames: 'rootDirectory player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMP'!

!AMPMusicPlayer class methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 11:58'!
defaultPath
	^'Z:\'! !

!AMPMusicPlayer methodsFor: 'as yet unclassified' stamp: 'SW 11/2/2010 10:59'!
initialize
	rootDirectory := FileDirectory forFileName:AMPMusicPlayer defaultPath.
	
	"AMPDirectory new for: AMPMusicPlayer defaultPath.
	rootDirectory openDirectory."! !

!AMPMusicPlayer methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:17'!
playSong: aFile
	self player stopPlaying.
	self player openFileNamed: aFile fullName.
	self player startPlaying.
! !

!AMPMusicPlayer methodsFor: 'as yet unclassified' stamp: 'SW 11/1/2010 18:07'!
player
	player ifNil: [player:=MPEGDisplayMorph new].
	^player! !

!AMPMusicPlayer methodsFor: 'as yet unclassified' stamp: 'SW 11/2/2010 10:30'!
rootDirectory 
	^rootDirectory
! !

!AMPMusicPlayer methodsFor: 'as yet unclassified' stamp: 'lw 11/3/2010 12:38'!
stopSong

	self player stopPlaying.
	! !
